# Very simple local_scan() functions -- unconditional accept/reject.
#
# If you wanted to use one of these local_scan_*() functions,
# you would copy it to exim_local_scan.py somewhere in your
# PYTHONPATH, and rename it to local_scan().  Not that you
# would want to -- they're just simplistic examples.

__revision__ = "$Id: simple.py,v 1.2 2002/10/20 21:46:23 gward Exp $"

from elspy import RejectMessage, TempRejectMessage


# Accept all messages.  Equivalent to
# int local_scan(int fd, uschar **return_text)
# {
#     return LOCAL_SCAN_ACCEPT;
# }
def local_scan_acceptall (info, headers, fd):
    return


# Reject all messages, with no custom error message.  Equivalent to
# int local_scan(int fd, uschar **return_text)
# {
#     return LOCAL_SCAN_REJECT;
# }
def local_scan_rejectall_1 (info, headers, fd):
    raise RejectMessage

# Reject all messages, with a custom (hard-coded) error message.
# Equivalent to
# int local_scan(int fd, uschar **return_text)
# {
#     *return_text = "sorry, I'm not accepting any mail today";
#     return LOCAL_SCAN_REJECT;
# }
def local_scan_rejectall_2 (info, headers, fd):
    raise RejectMessage("sorry, I'm not accepting any mail today")


# Temporarily reject (defer) all messages, with no custom error
# message.  Equivalent to
# int local_scan(int fd, uschar **return_text)
# {
#     return LOCAL_SCAN_TEMPREJECT;
# }
def local_scan_deferall_1 (info, headers, fd):
    raise TempRejectMessage

# Temporarily reject (defer) all messages, with a custom (hard-coded)
# error message.  Equivalent to
# int local_scan(int fd, uschar **return_text)
# {
#     *return_text = "sorry, I'm not feeling well -- try again later";
#     return LOCAL_SCAN_TEMPREJECT;
# }
def local_scan_deferall_2 (info, headers, fd):
    raise TempRejectMessage("sorry, I'm not feeling well -- try again later")
