#!/usr/bin/python2.1

# Pass a whole bunch of messages (one per file) through a single
# local_scan() function, and report the results.

__revision__ = "$Id: test_many.py,v 1.4 2002/10/20 22:26:58 gward Exp $"

import sys, os
from optik import OptionParser
from elspy.util import MessageDisposition
from test_util import \
     get_module, get_local_scan, create_message, \
     interpret_disposition, massage_text

def write (msg):
    sys.stdout.write(msg)
    sys.stdout.flush()

def main ():
    
    usage = "%prog test_module msgfile [...]"
    parser = OptionParser(usage)
    (options, args) = parser.parse_args()
    if not len(args) >= 2:
        parser.error("not enough arguments")

    test_module = args.pop(0)
    filenames = args

    mod = get_module(test_module)
    local_scan = get_local_scan(mod)

    for filename in filenames:
        write(filename + " ")
        (info, headers, fd) = create_message(filename)
        try:
            text = local_scan(info, headers, fd)
        except MessageDisposition, exc:
            (what, text) = interpret_disposition(exc, 30)
        else:
            what = "accepted"
            text = massage_text(text, 30)

        write("%s: %s\n" % (what, text))
        os.close(fd)

try:
    main()
except KeyboardInterrupt:
    sys.exit("interrupted")
