#!/usr/bin/python2.1

# Construct a fake local_scan() environment and pass it to
# a real local_scan() function.
#
# usage: test_message <test_module> <msg_file>
#
# test_module may be either a module name or a filename

__revision__ = "$Id: test_message.py,v 1.4 2002/10/20 22:27:26 gward Exp $"

import sys, os
import time

import elspy
from elspy.util import MessageDisposition
from test_util import \
     get_module, get_local_scan, create_message, interpret_disposition

sys.excepthook = elspy.old_excepthook

def main ():
    args = sys.argv[1:]
    if len(args) != 2:
        sys.exit("error: incorrect number of arguments")

    (test_module, msg_filename) = args
    mod = get_module(test_module)
    local_scan = get_local_scan(mod)
    (info, headers, fd) = create_message(msg_filename)

    try:
        val = local_scan(info, headers, fd)
    except MessageDisposition, exc:
        tb = sys.exc_info()[2]
        while tb.tb_next:
            tb = tb.tb_next

        code = tb.tb_frame.f_code
        file = code.co_filename
        func = code.co_name
        line = tb.tb_lineno

        (what, text) = interpret_disposition(exc)

        print "local_scan() %s message: %s" % (what, text)
        print "  from %s, line %d, in %s()" % (file, line, func)

    else:
        if val is None:
            print "local_scan() accepted message"
        else:
            print "local_scan() accepted message with return text %r" % val

    os.close(fd)

try:
    main()
except KeyboardInterrupt:
    sys.exit("interrupted")
